Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/src/test.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/SelfTest/src/test.cpp	(revision 128)
@@ -137,4 +137,75 @@
   sc_signal<Tcontrol_t> *  in_NRESET = new sc_signal<Tcontrol_t> ("NRESET");
 
+  sc_signal<Tcontrol_t         > ***  in_EXECUTE_LOOP_VAL                     ;
+  sc_signal<Tcontrol_t         > *** out_EXECUTE_LOOP_ACK                     ;
+  sc_signal<Tcontext_t         > ***  in_EXECUTE_LOOP_CONTEXT_ID              ;
+  sc_signal<Tcontext_t         > ***  in_EXECUTE_LOOP_FRONT_END_ID            ;
+  sc_signal<Tpacket_t          > ***  in_EXECUTE_LOOP_PACKET_ID               ;
+//sc_signal<Toperation_t       > ***  in_EXECUTE_LOOP_OPERATION               ;
+//sc_signal<Ttype_t            > ***  in_EXECUTE_LOOP_TYPE                    ;
+  sc_signal<Tspecial_data_t    > ***  in_EXECUTE_LOOP_FLAGS                   ;
+  sc_signal<Texception_t       > ***  in_EXECUTE_LOOP_EXCEPTION               ;
+  sc_signal<Tcontrol_t         > ***  in_EXECUTE_LOOP_NO_SEQUENCE             ;
+  sc_signal<Tgeneral_data_t    > ***  in_EXECUTE_LOOP_ADDRESS                 ;
+  sc_signal<Tgeneral_data_t    > ***  in_EXECUTE_LOOP_DATA                    ;
+
+  sc_signal<Tcontrol_t         >  ** out_COMMIT_VAL                           ;
+  sc_signal<Tcontrol_t         >  **  in_COMMIT_ACK                           ;
+  sc_signal<Tcontrol_t         >  ** out_COMMIT_WEN                           ;
+  sc_signal<Tcontext_t         >  ** out_COMMIT_CONTEXT_ID                    ;
+  sc_signal<Tcontext_t         >  ** out_COMMIT_FRONT_END_ID                  ;
+  sc_signal<Tpacket_t          >  ** out_COMMIT_PACKET_ID                     ;
+//sc_signal<Toperation_t       >  ** out_COMMIT_OPERATION                     ;
+//sc_signal<Ttype_t            >  ** out_COMMIT_TYPE                          ;
+  sc_signal<Tspecial_data_t    >  ** out_COMMIT_FLAGS                         ;
+  sc_signal<Texception_t       >  ** out_COMMIT_EXCEPTION                     ;
+  sc_signal<Tcontrol_t         >  ** out_COMMIT_NO_SEQUENCE                   ;
+  sc_signal<Tgeneral_data_t    >  ** out_COMMIT_ADDRESS                       ;
+  sc_signal<Tgeneral_address_t >  **  in_COMMIT_NUM_REG_RD                    ;
+
+  sc_signal<Tcontrol_t         >  ** out_SPR_VAL                              ;
+  sc_signal<Tcontrol_t         >  **  in_SPR_ACK                              ;
+  sc_signal<Tcontrol_t         >  ** out_SPR_WEN                              ;
+  sc_signal<Tcontext_t         >  ** out_SPR_CONTEXT_ID                       ;
+  sc_signal<Tcontext_t         >  ** out_SPR_FRONT_END_ID                     ;
+  sc_signal<Tspr_address_t     >  ** out_SPR_NUM_GROUP                        ;
+  sc_signal<Tspr_address_t     >  ** out_SPR_NUM_REG                          ;
+  sc_signal<Tspr_t             >  ** out_SPR_WDATA                            ;
+  sc_signal<Tspr_t             >  **  in_SPR_RDATA                            ;
+  sc_signal<Tcontrol_t         >  **  in_SPR_INVALID                          ;
+
+  sc_signal<Tcontrol_t         >  **  in_REEXECUTE_ROB_VAL                    ;
+  sc_signal<Tcontrol_t         >  ** out_REEXECUTE_ROB_ACK                    ;
+  sc_signal<Tcontext_t         >  **  in_REEXECUTE_ROB_CONTEXT_ID             ;
+  sc_signal<Tcontext_t         >  **  in_REEXECUTE_ROB_FRONT_END_ID           ;
+  sc_signal<Tpacket_t          >  **  in_REEXECUTE_ROB_PACKET_ID              ;
+  sc_signal<Toperation_t       >  **  in_REEXECUTE_ROB_OPERATION              ;
+  sc_signal<Ttype_t            >  **  in_REEXECUTE_ROB_TYPE                   ;
+  sc_signal<Tlsq_ptr_t         >  **  in_REEXECUTE_ROB_STORE_QUEUE_PTR_WRITE  ;
+
+  sc_signal<Tcontrol_t         >  ** out_REEXECUTE_VAL                        ;
+  sc_signal<Tcontrol_t         >  **  in_REEXECUTE_ACK                        ;
+  sc_signal<Tcontext_t         >  ** out_REEXECUTE_CONTEXT_ID                 ;
+  sc_signal<Tcontext_t         >  ** out_REEXECUTE_FRONT_END_ID               ;
+  sc_signal<Tpacket_t          >  ** out_REEXECUTE_PACKET_ID                  ;
+  sc_signal<Toperation_t       >  ** out_REEXECUTE_OPERATION                  ;
+  sc_signal<Ttype_t            >  ** out_REEXECUTE_TYPE                       ;
+  sc_signal<Tlsq_ptr_t         >  ** out_REEXECUTE_STORE_QUEUE_PTR_WRITE      ;
+  sc_signal<Tlsq_ptr_t         >  ** out_REEXECUTE_STORE_QUEUE_PTR_READ       ;
+  sc_signal<Tcontrol_t         >  ** out_REEXECUTE_STORE_QUEUE_EMPTY          ;
+  sc_signal<Tlsq_ptr_t         >  ** out_REEXECUTE_LOAD_QUEUE_PTR_WRITE       ;
+  sc_signal<Tcontrol_t         >  ** out_REEXECUTE_HAS_IMMEDIAT               ;
+  sc_signal<Tgeneral_data_t    >  ** out_REEXECUTE_IMMEDIAT                   ;
+  sc_signal<Tcontrol_t         >  ** out_REEXECUTE_READ_RA                    ;
+  sc_signal<Tgeneral_address_t >  ** out_REEXECUTE_NUM_REG_RA                 ;
+  sc_signal<Tcontrol_t         >  ** out_REEXECUTE_READ_RB                    ;
+  sc_signal<Tgeneral_address_t >  ** out_REEXECUTE_NUM_REG_RB                 ;
+  sc_signal<Tcontrol_t         >  ** out_REEXECUTE_READ_RC                    ;
+  sc_signal<Tspecial_address_t >  ** out_REEXECUTE_NUM_REG_RC                 ;
+  sc_signal<Tcontrol_t         >  ** out_REEXECUTE_WRITE_RD                   ;
+  sc_signal<Tgeneral_address_t >  ** out_REEXECUTE_NUM_REG_RD                 ;
+  sc_signal<Tcontrol_t         >  ** out_REEXECUTE_WRITE_RE                   ;
+  sc_signal<Tspecial_address_t >  ** out_REEXECUTE_NUM_REG_RE                 ;
+
   ALLOC2_SC_SIGNAL( in_EXECUTE_LOOP_VAL                     ," in_EXECUTE_LOOP_VAL                   ",Tcontrol_t         ,_param->_nb_execute_loop,_param->_nb_inst_execute[it1]);
   ALLOC2_SC_SIGNAL(out_EXECUTE_LOOP_ACK                     ,"out_EXECUTE_LOOP_ACK                   ",Tcontrol_t         ,_param->_nb_execute_loop,_param->_nb_inst_execute[it1]);
@@ -192,4 +263,6 @@
   ALLOC1_SC_SIGNAL(out_REEXECUTE_TYPE                       ,"out_REEXECUTE_TYPE                     ",Ttype_t            ,_param->_nb_inst_reexecute);
   ALLOC1_SC_SIGNAL(out_REEXECUTE_STORE_QUEUE_PTR_WRITE      ,"out_REEXECUTE_STORE_QUEUE_PTR_WRITE    ",Tlsq_ptr_t         ,_param->_nb_inst_reexecute);
+  ALLOC1_SC_SIGNAL(out_REEXECUTE_STORE_QUEUE_PTR_READ       ,"out_REEXECUTE_STORE_QUEUE_PTR_READ     ",Tlsq_ptr_t         ,_param->_nb_inst_reexecute);
+  ALLOC1_SC_SIGNAL(out_REEXECUTE_STORE_QUEUE_EMPTY          ,"out_REEXECUTE_STORE_QUEUE_EMPTY        ",Tcontrol_t         ,_param->_nb_inst_reexecute);
   ALLOC1_SC_SIGNAL(out_REEXECUTE_LOAD_QUEUE_PTR_WRITE       ,"out_REEXECUTE_LOAD_QUEUE_PTR_WRITE     ",Tlsq_ptr_t         ,_param->_nb_inst_reexecute);
   ALLOC1_SC_SIGNAL(out_REEXECUTE_HAS_IMMEDIAT               ,"out_REEXECUTE_HAS_IMMEDIAT             ",Tcontrol_t         ,_param->_nb_inst_reexecute);
@@ -284,4 +357,6 @@
   INSTANCE1_SC_SIGNAL(_Reexecute_unit,out_REEXECUTE_TYPE                       ,_param->_nb_inst_reexecute);
   INSTANCE1_SC_SIGNAL(_Reexecute_unit,out_REEXECUTE_STORE_QUEUE_PTR_WRITE      ,_param->_nb_inst_reexecute);
+  INSTANCE1_SC_SIGNAL(_Reexecute_unit,out_REEXECUTE_STORE_QUEUE_PTR_READ       ,_param->_nb_inst_reexecute);
+  INSTANCE1_SC_SIGNAL(_Reexecute_unit,out_REEXECUTE_STORE_QUEUE_EMPTY          ,_param->_nb_inst_reexecute);
   if (_param->_have_port_load_queue_ptr)
   INSTANCE1_SC_SIGNAL(_Reexecute_unit,out_REEXECUTE_LOAD_QUEUE_PTR_WRITE       ,_param->_nb_inst_reexecute);
@@ -475,4 +550,6 @@
 		TEST(Tcontrol_t        ,out_REEXECUTE_HAS_IMMEDIAT          [i]->read(), 1);
 		TEST(Tlsq_ptr_t        ,out_REEXECUTE_STORE_QUEUE_PTR_WRITE [i]->read(), 0);
+		TEST(Tlsq_ptr_t        ,out_REEXECUTE_STORE_QUEUE_PTR_READ  [i]->read(), 0);
+		TEST(Tlsq_ptr_t        ,out_REEXECUTE_STORE_QUEUE_EMPTY     [i]->read(), 0);
 		TEST(Tlsq_ptr_t        ,out_REEXECUTE_LOAD_QUEUE_PTR_WRITE  [i]->read(), 0);
 		TEST(Tcontrol_t        ,out_REEXECUTE_READ_RA               [i]->read(), 0);
@@ -568,4 +645,6 @@
   DELETE1_SC_SIGNAL(out_REEXECUTE_TYPE                       ,_param->_nb_inst_reexecute);
   DELETE1_SC_SIGNAL(out_REEXECUTE_STORE_QUEUE_PTR_WRITE      ,_param->_nb_inst_reexecute);
+  DELETE1_SC_SIGNAL(out_REEXECUTE_STORE_QUEUE_PTR_READ       ,_param->_nb_inst_reexecute);
+  DELETE1_SC_SIGNAL(out_REEXECUTE_STORE_QUEUE_EMPTY          ,_param->_nb_inst_reexecute);
   DELETE1_SC_SIGNAL(out_REEXECUTE_LOAD_QUEUE_PTR_WRITE       ,_param->_nb_inst_reexecute);
   DELETE1_SC_SIGNAL(out_REEXECUTE_HAS_IMMEDIAT               ,_param->_nb_inst_reexecute);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_statistics_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_statistics_deallocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/src/Free_List_unit_statistics_deallocation.cpp	(revision 128)
@@ -29,4 +29,5 @@
     delete _stat;
    
+    delete [] _stat_bank_spr_nb_elt;
     delete [] _stat_bank_gpr_nb_elt;
  
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/SelfTest/src/main.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/SelfTest/src/main.cpp	(revision 128)
@@ -67,4 +67,6 @@
       
       test (name,param);
+
+      delete param;
     }
   catch (morpheo::ErrorMorpheo & error)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/SelfTest/src/test.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/SelfTest/src/test.cpp	(revision 128)
@@ -50,4 +50,48 @@
   sc_clock              *  in_CLOCK  = new sc_clock ("clock", 1.0, 0.5);	 
   sc_signal<Tcontrol_t> *  in_NRESET = new sc_signal<Tcontrol_t> ("NRESET");
+
+  sc_signal<Tcontrol_t        >  **  in_RENAME_VAL               ;
+  sc_signal<Tcontrol_t        >  ** out_RENAME_ACK               ;
+  sc_signal<Tcontext_t        >  **  in_RENAME_FRONT_END_ID      ;
+  sc_signal<Tcontext_t        >  **  in_RENAME_CONTEXT_ID        ;
+  sc_signal<Tgeneral_address_t>  **  in_RENAME_NUM_REG_RA_LOG    ;
+  sc_signal<Tgeneral_address_t>  **  in_RENAME_NUM_REG_RB_LOG    ;
+  sc_signal<Tspecial_address_t>  **  in_RENAME_NUM_REG_RC_LOG    ;
+  sc_signal<Tgeneral_address_t>  **  in_RENAME_NUM_REG_RD_LOG    ;
+  sc_signal<Tspecial_address_t>  **  in_RENAME_NUM_REG_RE_LOG    ;
+  sc_signal<Tgeneral_address_t>  ** out_RENAME_NUM_REG_RA_PHY    ;
+  sc_signal<Tgeneral_address_t>  ** out_RENAME_NUM_REG_RB_PHY    ;
+  sc_signal<Tspecial_address_t>  ** out_RENAME_NUM_REG_RC_PHY    ;
+  sc_signal<Tgeneral_address_t>  ** out_RENAME_NUM_REG_RD_PHY_OLD;
+  sc_signal<Tspecial_address_t>  ** out_RENAME_NUM_REG_RE_PHY_OLD;
+
+  sc_signal<Tcontrol_t        >  **  in_INSERT_VAL               ;
+  sc_signal<Tcontrol_t        >  ** out_INSERT_ACK               ;
+//sc_signal<Tcontext_t        >  **  in_INSERT_FRONT_END_ID      ;
+//sc_signal<Tcontext_t        >  **  in_INSERT_CONTEXT_ID        ;
+  sc_signal<Tcontrol_t        >  **  in_INSERT_WRITE_RD          ;
+  sc_signal<Tcontrol_t        >  **  in_INSERT_WRITE_RE          ;
+  sc_signal<Tgeneral_address_t>  **  in_INSERT_NUM_REG_RD_LOG    ;
+  sc_signal<Tspecial_address_t>  **  in_INSERT_NUM_REG_RE_LOG    ;
+  sc_signal<Tgeneral_address_t>  **  in_INSERT_NUM_REG_RD_PHY    ;
+  sc_signal<Tspecial_address_t>  **  in_INSERT_NUM_REG_RE_PHY    ;
+
+  sc_signal<Tcontrol_t        >  **  in_RETIRE_VAL               ;
+  sc_signal<Tcontrol_t        >  ** out_RETIRE_ACK               ;
+  sc_signal<Tcontext_t        >  **  in_RETIRE_FRONT_END_ID      ;
+  sc_signal<Tcontext_t        >  **  in_RETIRE_CONTEXT_ID        ;
+  sc_signal<Tcontrol_t        >  **  in_RETIRE_WRITE_RD          ;
+  sc_signal<Tcontrol_t        >  **  in_RETIRE_WRITE_RE          ;
+  sc_signal<Tgeneral_address_t>  **  in_RETIRE_NUM_REG_RD_LOG    ;
+  sc_signal<Tspecial_address_t>  **  in_RETIRE_NUM_REG_RE_LOG    ;
+  sc_signal<Tgeneral_address_t>  **  in_RETIRE_NUM_REG_RD_PHY_NEW;
+  sc_signal<Tspecial_address_t>  **  in_RETIRE_NUM_REG_RE_PHY_NEW;
+  sc_signal<Tcontrol_t        >  ** out_RETIRE_RESTORE_RD_PHY_OLD;
+  sc_signal<Tcontrol_t        >  ** out_RETIRE_RESTORE_RE_PHY_OLD;
+  sc_signal<Tcontrol_t        >  ** out_RETIRE_RESTORE           ;
+
+  sc_signal<Tcontrol_t        > ***  in_RETIRE_EVENT_VAL         ;
+  sc_signal<Tcontrol_t        > *** out_RETIRE_EVENT_ACK         ;
+  sc_signal<Tevent_state_t    > ***  in_RETIRE_EVENT_STATE       ;
 
   ALLOC1_SC_SIGNAL( in_RENAME_VAL               ," in_RENAME_VAL               ",Tcontrol_t        ,_param->_nb_inst_insert);
@@ -85,6 +129,6 @@
   ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RD_LOG    ," in_RETIRE_NUM_REG_RD_LOG    ",Tgeneral_address_t,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RE_LOG    ," in_RETIRE_NUM_REG_RE_LOG    ",Tspecial_address_t,_param->_nb_inst_retire);
-  ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RD_PHY_OLD," in_RETIRE_NUM_REG_RD_PHY_OLD",Tgeneral_address_t,_param->_nb_inst_retire);
-  ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RE_PHY_OLD," in_RETIRE_NUM_REG_RE_PHY_OLD",Tspecial_address_t,_param->_nb_inst_retire);
+  ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RD_PHY_NEW," in_RETIRE_NUM_REG_RD_PHY_NEW",Tgeneral_address_t,_param->_nb_inst_retire);
+  ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RE_PHY_NEW," in_RETIRE_NUM_REG_RE_PHY_NEW",Tspecial_address_t,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL(out_RETIRE_RESTORE_RD_PHY_OLD,"out_RETIRE_RESTORE_RD_PHY_OLD",Tcontrol_t        ,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL(out_RETIRE_RESTORE_RE_PHY_OLD,"out_RETIRE_RESTORE_RE_PHY_OLD",Tcontrol_t        ,_param->_nb_inst_retire);
@@ -144,6 +188,6 @@
   INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit, in_RETIRE_NUM_REG_RD_LOG    ,_param->_nb_inst_retire);
   INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit, in_RETIRE_NUM_REG_RE_LOG    ,_param->_nb_inst_retire);
-  INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit, in_RETIRE_NUM_REG_RD_PHY_OLD,_param->_nb_inst_retire);
-  INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit, in_RETIRE_NUM_REG_RE_PHY_OLD,_param->_nb_inst_retire);
+  INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit, in_RETIRE_NUM_REG_RD_PHY_NEW,_param->_nb_inst_retire);
+  INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit, in_RETIRE_NUM_REG_RE_PHY_NEW,_param->_nb_inst_retire);
   INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit,out_RETIRE_RESTORE_RD_PHY_OLD,_param->_nb_inst_retire);
   INSTANCE1_SC_SIGNAL(_Register_Address_Translation_unit,out_RETIRE_RESTORE_RE_PHY_OLD,_param->_nb_inst_retire);
@@ -272,6 +316,6 @@
 	      in_RETIRE_NUM_REG_RD_LOG     [i]->write(rand() % _param->_nb_general_register_logic);
 	      in_RETIRE_NUM_REG_RE_LOG     [i]->write(rand() % _param->_nb_special_register_logic);
-	      in_RETIRE_NUM_REG_RD_PHY_OLD [i]->write(rand() % _param->_nb_general_register);
-	      in_RETIRE_NUM_REG_RE_PHY_OLD [i]->write(rand() % _param->_nb_special_register);
+	      in_RETIRE_NUM_REG_RD_PHY_NEW [i]->write(rand() % _param->_nb_general_register);
+	      in_RETIRE_NUM_REG_RE_PHY_NEW [i]->write(rand() % _param->_nb_special_register);
 
 	      in_RETIRE_EVENT_STATE        [front_end_id][context_id]->write(EVENT_STATE_NO_EVENT);
@@ -409,6 +453,6 @@
 	      in_RETIRE_NUM_REG_RD_LOG     [i]->write(rand() % _param->_nb_general_register_logic);
 	      in_RETIRE_NUM_REG_RE_LOG     [i]->write(rand() % _param->_nb_special_register_logic);
-	      in_RETIRE_NUM_REG_RD_PHY_OLD [i]->write(rand() % _param->_nb_general_register);
-	      in_RETIRE_NUM_REG_RE_PHY_OLD [i]->write(rand() % _param->_nb_special_register);
+	      in_RETIRE_NUM_REG_RD_PHY_NEW [i]->write(rand() % _param->_nb_general_register);
+	      in_RETIRE_NUM_REG_RE_PHY_NEW [i]->write(rand() % _param->_nb_special_register);
 
               in_RETIRE_EVENT_STATE [retire_front_end_id [i]][retire_context_id [i]]->write(EVENT_STATE_WAITEND);
@@ -451,5 +495,5 @@
 
 		      if (rat_gpr_updt [front_end_id][context_id][in_RETIRE_NUM_REG_RD_LOG[i]->read()] == false)
-			rat_gpr[front_end_id][context_id][in_RETIRE_NUM_REG_RD_LOG[i]->read()] = in_RETIRE_NUM_REG_RD_PHY_OLD[i]->read();
+			rat_gpr[front_end_id][context_id][in_RETIRE_NUM_REG_RD_LOG[i]->read()] = in_RETIRE_NUM_REG_RD_PHY_NEW[i]->read();
 		      rat_gpr_updt [front_end_id][context_id][in_RETIRE_NUM_REG_RD_LOG[i]->read()] = true;
 		    }
@@ -459,5 +503,5 @@
 
 		      if (rat_spr_updt [front_end_id][context_id][in_RETIRE_NUM_REG_RE_LOG[i]->read()] == false)
-			rat_spr[front_end_id][context_id][in_RETIRE_NUM_REG_RE_LOG[i]->read()] = in_RETIRE_NUM_REG_RE_PHY_OLD[i]->read();
+			rat_spr[front_end_id][context_id][in_RETIRE_NUM_REG_RE_LOG[i]->read()] = in_RETIRE_NUM_REG_RE_PHY_NEW[i]->read();
 		      rat_spr_updt [front_end_id][context_id][in_RETIRE_NUM_REG_RE_LOG[i]->read()] = true;
 		    }
@@ -498,53 +542,48 @@
   delete in_NRESET;
 
-  delete []  in_RENAME_VAL               ;
-  delete [] out_RENAME_ACK               ;
-  if (_param->_have_port_front_end_id)
-  delete []  in_RENAME_FRONT_END_ID      ;
-  if (_param->_have_port_context_id)
-  delete []  in_RENAME_CONTEXT_ID        ;
-  delete []  in_RENAME_NUM_REG_RA_LOG    ;
-  delete []  in_RENAME_NUM_REG_RB_LOG    ;
-  delete []  in_RENAME_NUM_REG_RC_LOG    ;
-  delete []  in_RENAME_NUM_REG_RD_LOG    ;
-  delete []  in_RENAME_NUM_REG_RE_LOG    ;
-  delete [] out_RENAME_NUM_REG_RA_PHY    ;
-  delete [] out_RENAME_NUM_REG_RB_PHY    ;
-  delete [] out_RENAME_NUM_REG_RC_PHY    ;
-  delete [] out_RENAME_NUM_REG_RD_PHY_OLD;
-  delete [] out_RENAME_NUM_REG_RE_PHY_OLD;
-
-  delete []  in_INSERT_VAL               ;
-  delete [] out_INSERT_ACK               ;
-//if (_param->_have_port_front_end_id)
-//delete []  in_INSERT_FRONT_END_ID      ;
-//if (_param->_have_port_context_id)
-//delete []  in_INSERT_CONTEXT_ID        ;
-  delete []  in_INSERT_WRITE_RD          ;
-  delete []  in_INSERT_WRITE_RE          ;
-  delete []  in_INSERT_NUM_REG_RD_LOG    ;
-  delete []  in_INSERT_NUM_REG_RE_LOG    ;
-  delete []  in_INSERT_NUM_REG_RD_PHY    ;
-  delete []  in_INSERT_NUM_REG_RE_PHY    ;
-
-  delete []  in_RETIRE_VAL               ;
-  delete [] out_RETIRE_ACK               ;
-  if (_param->_have_port_front_end_id)
-  delete []  in_RETIRE_FRONT_END_ID      ;
-  if (_param->_have_port_context_id)
-  delete []  in_RETIRE_CONTEXT_ID        ;
-  delete []  in_RETIRE_WRITE_RD          ;
-  delete []  in_RETIRE_WRITE_RE          ;
-  delete []  in_RETIRE_NUM_REG_RD_LOG    ;
-  delete []  in_RETIRE_NUM_REG_RE_LOG    ;
-  delete []  in_RETIRE_NUM_REG_RD_PHY_OLD;
-  delete []  in_RETIRE_NUM_REG_RE_PHY_OLD;
-  delete [] out_RETIRE_RESTORE_RD_PHY_OLD;
-  delete [] out_RETIRE_RESTORE_RE_PHY_OLD;
-  delete [] out_RETIRE_RESTORE           ;
-
-  DELETE2_SC_SIGNAL( in_RETIRE_EVENT_VAL            ,_param->_nb_front_end, _param->_nb_context[it1]);
-  DELETE2_SC_SIGNAL(out_RETIRE_EVENT_ACK            ,_param->_nb_front_end, _param->_nb_context[it1]);
-  DELETE2_SC_SIGNAL( in_RETIRE_EVENT_STATE          ,_param->_nb_front_end, _param->_nb_context[it1]);
+
+  DELETE1_SC_SIGNAL( in_RENAME_VAL               ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL(out_RENAME_ACK               ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_RENAME_FRONT_END_ID      ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_RENAME_CONTEXT_ID        ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_RENAME_NUM_REG_RA_LOG    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_RENAME_NUM_REG_RB_LOG    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_RENAME_NUM_REG_RC_LOG    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_RENAME_NUM_REG_RD_LOG    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_RENAME_NUM_REG_RE_LOG    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL(out_RENAME_NUM_REG_RA_PHY    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL(out_RENAME_NUM_REG_RB_PHY    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL(out_RENAME_NUM_REG_RC_PHY    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL(out_RENAME_NUM_REG_RD_PHY_OLD,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL(out_RENAME_NUM_REG_RE_PHY_OLD,_param->_nb_inst_insert);
+
+  DELETE1_SC_SIGNAL( in_INSERT_VAL               ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL(out_INSERT_ACK               ,_param->_nb_inst_insert);
+//DELETE1_SC_SIGNAL( in_INSERT_FRONT_END_ID      ,_param->_nb_inst_insert);
+//DELETE1_SC_SIGNAL( in_INSERT_CONTEXT_ID        ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_INSERT_WRITE_RD          ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_INSERT_WRITE_RE          ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_INSERT_NUM_REG_RD_LOG    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_INSERT_NUM_REG_RE_LOG    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_INSERT_NUM_REG_RD_PHY    ,_param->_nb_inst_insert);
+  DELETE1_SC_SIGNAL( in_INSERT_NUM_REG_RE_PHY    ,_param->_nb_inst_insert);
+
+  DELETE1_SC_SIGNAL( in_RETIRE_VAL               ,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL(out_RETIRE_ACK               ,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL( in_RETIRE_FRONT_END_ID      ,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL( in_RETIRE_CONTEXT_ID        ,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL( in_RETIRE_WRITE_RD          ,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL( in_RETIRE_WRITE_RE          ,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL( in_RETIRE_NUM_REG_RD_LOG    ,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL( in_RETIRE_NUM_REG_RE_LOG    ,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL( in_RETIRE_NUM_REG_RD_PHY_NEW,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL( in_RETIRE_NUM_REG_RE_PHY_NEW,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL(out_RETIRE_RESTORE_RD_PHY_OLD,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL(out_RETIRE_RESTORE_RE_PHY_OLD,_param->_nb_inst_retire);
+  DELETE1_SC_SIGNAL(out_RETIRE_RESTORE           ,_param->_nb_inst_retire);
+
+  DELETE2_SC_SIGNAL( in_RETIRE_EVENT_VAL         ,_param->_nb_front_end,_param->_nb_context[it1]);
+  DELETE2_SC_SIGNAL(out_RETIRE_EVENT_ACK         ,_param->_nb_front_end,_param->_nb_context[it1]);
+  DELETE2_SC_SIGNAL( in_RETIRE_EVENT_STATE       ,_param->_nb_front_end,_param->_nb_context[it1]);
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Register_Address_Translation_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Register_Address_Translation_unit_transition.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Register_Address_Translation_unit/src/Register_Address_Translation_unit_transition.cpp	(revision 128)
@@ -36,4 +36,6 @@
 	      rat_gpr_not_speculative   [i][j][0] = 0;
               rat_gpr_speculative_valid [i][j][0] = false;
+              rat_gpr_speculative       [i][j][0] = 0    ; // not necessary
+              rat_gpr_update_table      [i][j][0] = false; // not necessary
 
 	      for (uint32_t k=1; k<_param->_nb_general_register_logic; k++)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/src/Parameters.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/src/Parameters.cpp	(revision 128)
@@ -127,9 +127,9 @@
     log_printf(FUNC,Register_translation_unit,FUNCTION,"Begin");
 
-    delete [] _param_dependency_checking_unit;
-    delete [] _param_free_list_unit;
-    delete [] _param_register_address_translation_unit;
-    delete [] _param_stat_list_unit;    
-    delete [] _param_register_translation_unit_glue;
+    delete _param_dependency_checking_unit;
+    delete _param_free_list_unit;
+    delete _param_register_address_translation_unit;
+    delete _param_stat_list_unit;    
+    delete _param_register_translation_unit_glue;
 
     log_printf(FUNC,Register_translation_unit,FUNCTION,"End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/SelfTest/src/main.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/SelfTest/src/main.cpp	(revision 128)
@@ -135,4 +135,6 @@
       
       test (name,param);
+      
+      delete param;
     }
   catch (morpheo::ErrorMorpheo & error)
